unit FAVISel;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Animate, Dialogs;

type
  TSelectAVIForm = class(TForm)
    CopyFileRadio: TRadioButton;
    MoveFileRadio: TRadioButton;
    DeleteFileRadio: TRadioButton;
    EmptyBinRadio: TRadioButton;
    EmptyFolderRadio: TRadioButton;
    SearchHardwareRadio: TRadioButton;
    SearchFileRadio: TRadioButton;
    SearchFolderRadio: TRadioButton;
    UserDefinedRadio: TRadioButton;
    InfoLabel: TLabel;
    Bevel1: TBevel;
    OKButton: TButton;
    CancelButton: TButton;
    Bevel2: TBevel;
    OpenDialog: TOpenDialog;
    AnimationLabel: TLabel;
    Animation: TAnimation;
    Bevel3: TBevel;
    procedure RadioButtonClicked(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure UserDefinedRadioClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SelectRadioButton;
  public
    function Execute: Boolean;
  end;

var
  SelectAVIForm: TSelectAVIForm;

implementation

{$R *.DFM}

procedure TSelectAVIForm.RadioButtonClicked(Sender: TObject);
begin
  with Sender as TRadioButton do
  begin
    Animation.Animation := (Sender as TRadioButton).Caption;

    // Let control resize to fit the AVI size.
    Animation.Center := True;
    Animation.Center := False;

    Animation.Playing := True;
    AnimationLabel.Caption := Animation.Animation;
  end;
end;

procedure TSelectAVIForm.OKButtonClick(Sender: TObject);
begin
  Close;
  ModalResult := mrOK;
end;

procedure TSelectAVIForm.CancelButtonClick(Sender: TObject);
begin
  Close;
  ModalResult := mrCancel;
end;

procedure TSelectAVIForm.UserDefinedRadioClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    AnimationLabel.Caption := OpenDialog.FileName;
    Animation.Animation := OpenDialog.FileName;
  end
  else
    SelectRadioButton;
end;

function TSelectAVIForm.Execute: Boolean;
begin
  ShowModal;
  Result := ModalResult = mrOk;
end;

procedure TSelectAVIForm.SelectRadioButton;
begin
  case Animation.Resource of
    arCopyFile: ActiveControl := CopyFileRadio;
    arMoveFile: ActiveControl := MoveFileRadio;
    arDeleteFile: ActiveControl := DeleteFileRadio;
    arEmptyBin: ActiveControl := EmptyBinRadio;
    arEmptyFolder: ActiveControl := EmptyFolderRadio;
    arSearchFile: ActiveControl := SearchFileRadio;
    arSearchFolder: ActiveControl := SearchFolderRadio;
    arSearchHardware: ActiveControl := SearchHardwareRadio;
    arUser: ActiveControl := UserDefinedRadio;
    arNone: ActiveControl := OKButton;
  end;
end;

procedure TSelectAVIForm.FormActivate(Sender: TObject);
begin
  AnimationLabel.Caption := Animation.Animation;
  SelectRadioButton;
end;

end.
